#!/usr/bin/env python
import pdb,sys,os


X=24 # length of all considering length


# read in the nonred.shorten motifs
f=open(sys.argv[1],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split() for item in lf]

for i in range(len(lf)):
	mt=int(lf[i][0].split(";")[0].split(",")[1])
	ma=[]
	tg=lf[i][0].split(";")
	tg=[item.split(",") for item in tg]
	ma=[item[1] for item in tg]
	tg=[item[0] for item in tg]
	tg=list(set(tg))
	ma=list(set(ma))
	tg.sort()
	lf[i]=[mt,ma,tg,lf[i][-1]]
lf.sort()
mot=lf

# read in the mc
f=open(sys.argv[2],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split() for item in lf]
mc_tmp=lf[:]
lf=[item[:-2] for item in lf]
mc=lf


# read in the original predicted motifs
f=open(sys.argv[3],'r')
lf=f.readlines()
f.close()
lf="".join(lf)
lf=lf.split(">")[1:]
lf=[item.split("\n") for item in lf]
for i in range(len(lf)):
	lf[i]=[item for item in lf[i] if item!=""]
m=lf

########################################################################
for i in range(len(mc)):
	for j in range(len(mc[i])):
		for k in range(len(mot)):
			if (mc[i][j][1:] in mot[k][1]) and (str(i) in mot[k][2]):
				mc[i][j]="M"+str(k)
				#pdb.set_trace()
				break
				
# output the motifs

#########################################################################

def cons(a):
	dN="ACGT"
	con=""
	for i in range(len(a)):
		a[i]=a[i].split(" ")
		a[i]=[float(item) for item in a[i]]
		con+=dN[a[i].index(max(a[i]))]
	return con

########################################################################



#########################################################################
def mismatch(a,b):
	mis=[i for i in range(len(a)) if a[i]!=b[i]]
	return len(mis)
#

########################################################################
def loc_mot(mo,mn):
	con_mo=cons(mo)
	x=len(con_mo)
	# if extension
	if len(con_mo)<=len(mn):
		NM=[]
		for i in range(len(mn)-len(con_mo)+1):
			NM.append(mismatch(con_mo,mn[i:i+len(con_mo)]))
		IDS=NM.index(min(NM))
		LP=(X-x)/2-IDS
		RP=LP+len(mn)
	else:
		NM=[]
		for i in range(len(con_mo)-len(mn)+1):
			NM.append(mismatch(mn,con_mo[i:i+len(mn)]))
		IDS=NM.index(min(NM))
		LP=(X-x)/2+IDS
		RP=LP+len(mn)
		
	return [LP,RP]
	
########################################################################
#######################################################################
# get_matrix
def get_matrix(A):
	dN={"A":0,"C":1,"G":2,"T":3}
	pc=0.01
	mat=[]
	x=len(A[0])
	for i in range(x):
		N=[0,0,0,0]
		for j in A:
			N[dN[j[i]]]+=1
		N=[float(item)/sum(N) for item in N]
		N=[round(item,4) for item in N]
		N=[item+pc for item in N]
		N=[float(item)/sum(N) for item in N]
		N=[round(item,4) for item in N]
		N=[str(item) for item in N]
		N=" ".join(N)
		mat.append(N)
	return mat
	
		


#############################################################################

# read in XMS
f=open(sys.argv[3]+".XMS",'r')
lf=f.readlines()
f.close()
lf=[item.strip().split(",") for item in lf]
XMS=lf

f=open(sys.argv[3]+".XMID",'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
XMID=lf
XMID=[int(item) for item in XMID]


#########################################################################

for i in range(len(mot)):
	old_ind=int(mot[i][1][0])
	score=m[old_ind][0].split()[-1]
	pos=loc_mot(m[old_ind][1:],mot[i][-1])
	if old_ind in XMID:
		XS=XMS[XMID.index(old_ind)]
		TXS=[]
		for j in XS:
			TXS.append(j[pos[0]:pos[1]])
		Mat=get_matrix(TXS)
		#pdb.set_trace()
		Mat="\n".join(Mat)
		mot[i]=">M"+str(i)+"\t"+score+"\n"+Mat
	else:
		Mat=m[old_ind][1:]
		Mat="\n".join(Mat)
		mot[i]=">M"+str(i)+"\t"+score+"\n"+Mat
		
	
mot="\n".join(mot)
f=open(sys.argv[1]+".final",'w')
f.write(mot)
f.close()
# output the motif modules

for i in range(len(mc)):
	mc[i]=mc[i]+mc_tmp[i][-2:]
	mc[i]="\t".join(mc[i])
mc="\n".join(mc)
f=open(sys.argv[2]+".final",'w')
f.write(mc)
f.close()


				
